/********************************************************************
	Rhapsody	: 8.1.2 
	Login		: GB080220
	Component	: MulticastUsingStandardPorts 
	Configuration 	: DefaultConfig
	Model Element	: R1
//!	Generated Date	: Thu, 11, Jun 2015  
	File Path	: MulticastUsingStandardPorts\DefaultConfig\R1.cpp
*********************************************************************/

//## auto_generated
#include <oxf\omthread.h>
//## auto_generated
#include "R1.h"
//## package Default

//## class R1
//#[ ignore
R1::p_C::p_C() : _p_(0) {
}

R1::p_C::~p_C() {
}

void R1::p_C::connectR1(R1* part) {
    InBound.addItsDefaultProvidedInterface(part);
    InBound.setPort(this); // for IS_PORT macro support
    
}
//#]

R1::R1(IOxfActive* theActiveContext) {
    setActiveContext(theActiveContext, false);
    initRelations();
    initStatechart();
}

R1::~R1() {
}

R1::p_C* R1::getP() const {
    return (R1::p_C*) &p;
}

R1::p_C* R1::get_p() const {
    return (R1::p_C*) &p;
}

bool R1::startBehavior() {
    bool done = false;
    done = OMReactive::startBehavior();
    return done;
}

void R1::initRelations() {
    if (get_p() != NULL) {
        get_p()->connectR1(this);
    }
}

void R1::initStatechart() {
    rootState_subState = OMNonState;
    rootState_active = OMNonState;
}

void R1::rootState_entDef() {
    {
        rootState_subState = idle;
        rootState_active = idle;
    }
}

IOxfReactive::TakeEventStatus R1::rootState_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    // State idle
    if(rootState_active == idle)
        {
            if(IS_EVENT_TYPE_OF(updated_Default_id))
                {
                    //#[ transition 1 
                    std::cout << "R1" << std::endl;
                    //#]
                    rootState_subState = idle;
                    rootState_active = idle;
                    res = eventConsumed;
                }
            
        }
    return res;
}

/*********************************************************************
	File Path	: MulticastUsingStandardPorts\DefaultConfig\R1.cpp
*********************************************************************/
