/********************************************************************
	Rhapsody	: 8.1.2 
	Login		: GB080220
	Component	: MulticastUsingStandardPorts 
	Configuration 	: DefaultConfig
	Model Element	: R2
//!	Generated Date	: Thu, 11, Jun 2015  
	File Path	: MulticastUsingStandardPorts\DefaultConfig\R2.cpp
*********************************************************************/

//## auto_generated
#include <oxf\omthread.h>
//## auto_generated
#include "R2.h"
//## package Default

//## class R2
//#[ ignore
R2::p_C::p_C() : _p_(0) {
}

R2::p_C::~p_C() {
}

void R2::p_C::connectR2(R2* part) {
    InBound.addItsDefaultProvidedInterface(part);
    InBound.setPort(this); // for IS_PORT macro support
    
}
//#]

R2::R2(IOxfActive* theActiveContext) {
    setActiveContext(theActiveContext, false);
    initRelations();
    initStatechart();
}

R2::~R2() {
}

R2::p_C* R2::getP() const {
    return (R2::p_C*) &p;
}

R2::p_C* R2::get_p() const {
    return (R2::p_C*) &p;
}

bool R2::startBehavior() {
    bool done = false;
    done = OMReactive::startBehavior();
    return done;
}

void R2::initRelations() {
    if (get_p() != NULL) {
        get_p()->connectR2(this);
    }
}

void R2::initStatechart() {
    rootState_subState = OMNonState;
    rootState_active = OMNonState;
}

void R2::rootState_entDef() {
    {
        rootState_subState = idle;
        rootState_active = idle;
    }
}

IOxfReactive::TakeEventStatus R2::rootState_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    // State idle
    if(rootState_active == idle)
        {
            if(IS_EVENT_TYPE_OF(updated_Default_id))
                {
                    //#[ transition 1 
                    std::cout << "R2" << std::endl;
                    //#]
                    rootState_subState = idle;
                    rootState_active = idle;
                    res = eventConsumed;
                }
            
        }
    return res;
}

/*********************************************************************
	File Path	: MulticastUsingStandardPorts\DefaultConfig\R2.cpp
*********************************************************************/
