/********************************************************************
	Rhapsody	: 8.1.2 
	Login		: GB080220
	Component	: MulticastUsingStandardPorts 
	Configuration 	: DefaultConfig
	Model Element	: S1
//!	Generated Date	: Thu, 11, Jun 2015  
	File Path	: MulticastUsingStandardPorts\DefaultConfig\S1.cpp
*********************************************************************/

//## auto_generated
#include <oxf\omthread.h>
//## auto_generated
#include "S1.h"
//## package Default

//## class S1
//#[ ignore
S1::p_C::p_C() : _p_(0) {
}

S1::p_C::~p_C() {
}

void S1::p_C::connectS1(S1* part) {
    InBound.addItsDefaultProvidedInterface(part);
    InBound.setPort(this); // for IS_PORT macro support
    
}
//#]

S1::S1(IOxfActive* theActiveContext) {
    setActiveContext(theActiveContext, false);
    initRelations();
    initStatechart();
}

S1::~S1() {
}

S1::p_C* S1::getP() const {
    return (S1::p_C*) &p;
}

S1::p_C* S1::get_p() const {
    return (S1::p_C*) &p;
}

bool S1::startBehavior() {
    bool done = false;
    done = OMReactive::startBehavior();
    return done;
}

void S1::initRelations() {
    if (get_p() != NULL) {
        get_p()->connectS1(this);
    }
}

void S1::initStatechart() {
    rootState_subState = OMNonState;
    rootState_active = OMNonState;
}

void S1::rootState_entDef() {
    {
        pushNullTransition();
        rootState_subState = idle;
        rootState_active = idle;
    }
}

IOxfReactive::TakeEventStatus S1::rootState_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    // State idle
    if(rootState_active == idle)
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    popNullTransition();
                    rootState_subState = sendaction_2;
                    rootState_active = sendaction_2;
                    //#[ state sendaction_2.(Entry) 
                    MULTICAST_GEN(p,updated);
                    //#]
                    res = eventConsumed;
                }
            
        }
    return res;
}

/*********************************************************************
	File Path	: MulticastUsingStandardPorts\DefaultConfig\S1.cpp
*********************************************************************/
